<?PHP
/*
Plugin Name: Commentwitter
Plugin URI: http://www.jonbishop.org/commentwitter-plugin-page
Description: A WordPress Plugin to integrate Twitter and WordPress Comments
Version: 1.4.2
Author: Jon Bishop
Author URI: http://www.jonbishop.org
*/


// display the notice under the comment form
function get_commentwitter_input() {
if ( !defined('WP_CONTENT_URL') )
	define( 'WP_CONTENT_URL', get_option('siteurl') . '/wp-content');
// Guess the location
$commentwitterpluginpath = WP_CONTENT_URL.'/plugins/'.plugin_basename(dirname(__FILE__)).'/';
	?>
<a href="#" id="slick-slidetoggle">Send To Twitter</a> 
<?
if(get_option('commentwitter_settings')){
		$settings=array();
		$settings=unserialize(get_option('commentwitter_settings'));
	} else {
		$settings=array();
		$settings['commentwitter_whats_this']="on";
	}
	if($settings['commentwitter_whats_this']){
	?>
	<a href="http://www.jonbishop.org/commentwitter-plugin-page/?utm_source=CommenTwitter&utm_medium=More%2BInfo%20Button&utm_campaign=Web%2BSite" target="_blank" title="What's CommenTwitter?"><img src="<?=$commentwitterpluginpath; ?>/help_icon.png" alt="What's CommenTwitter?"/></a>
	<?
	} 
	?>
    <div id="toggle-twitter">
<p style="padding:10px 0px 10px 0px;"><input type="text" name="twittername" id="twittername" value="" size="22" />
<label for="author"><small>Twitter Name</small></label></p>
<p style="padding:10px 0px 10px 0px;"><input type="password" name="twitterpass" id="twitterpass" value="" size="22" />
<label for="author"><small>Twitter Password</small></label></p>
</div>
    <?
}


// comments form processing
function Commentwitter_form_action($comment_ID) {
	
	$tweet = "";
	$twitterURI = "/statuses/update.xml";
	
	$comment_data = get_comment($comment_ID, ARRAY_A);
	$postID = $comment_data['comment_post_ID'];
	
	$thispostlink = get_permalink($postID) . '#comment-' . $comment_ID;
	$thisposttitle = single_post_title('', FALSE);
	
	$tweet  = stripslashes(trim($_POST['comment']));
	
	$twit = Create_tweet($tweet, $thispostlink, $thisposttitle);
	
	 // send
  	$error_code = null; 
	$error_text = null;
	
	$twitname = $_POST['twittername'];
	$twitpass = $_POST['twitterpass'];
	
  	$retval = Commenter_twitter_send( $twit, $twitname, $twitpass, $error_code, $error_text );
	$comment_status = wp_get_comment_status($comment_ID);
	
	if ($comment_status=="approved"||$comment_status==1||$comment_status=="approve"){
		Author_twitter_send($comment_ID, $comment_status);
	}
}

function Create_tweet($tweet, $thispostlink="", $thisposttitle=""){
	if(get_option('commentwitter_settings')){
		$settings=array();
		$settings=unserialize(get_option('commentwitter_settings'));
	} else {
		$settings=array();
		$settings['commentwitter_api']="";
		$settings['commentwitter_cligs_api']="";
	}
	if($settings['commentwitter_cligs_api']!=""){
		$clig_api = "&key=".$settings['commentwitter_cligs_api']."&appid=Commentwitter";
	} else {
		$clig_api = "";
	}
	$tinyurl = file_get_contents("http://cli.gs/api/v1/cligs/create?url=".urlencode($thispostlink)."&title=".urlencode($thisposttitle).$clig_api);
    if(strlen($tweet)<120){
		$twit = $tweet . " " . $tinyurl;
	} else {
		$twit = substr($tweet,0,115) . '... ' . $tinyurl;
	}
	return $twit;
}

function Commentwitter_wp_head(){

// Pre-2.6 compatibility
if ( !defined('WP_CONTENT_URL') )
    define( 'WP_CONTENT_URL', get_option('siteurl') . '/wp-content');
// Guess the location
$commentwitterpluginpath = WP_CONTENT_URL.'/plugins/'.plugin_basename(dirname(__FILE__)).'/';
echo '<script language="JavaScript" type="text/javascript" src="' . $commentwitterpluginpath . 'commentwitter.js"></script>'."\n";
}


function Commenter_twitter_send( $text, $twitname, $twitpass, &$r_error_code, &$r_error_text ) {
	
	if((isset($twitname) && $twitname!="") && (isset($twitpass) && $twitpass!="")){
	
  $host = 'twitter.com';
  $port = 80;
  $uri = '/statuses/update.xml';
  $param = 'status';
  $timeout = 10;
 
  $login = base64_encode( $twitname
      .':'
      .strip_tags(stripslashes($twitpass)) );
  
  // connect
  $r_error_code = null; 
  $r_error_text = null;
	$fp = @fsockopen( $host, $port, $r_error_code, $r_error_text, $timeout );
  if( !$fp )
    return false;
    
  // send  
  $content = $param.'='.urlencode($text);
  @fwrite( $fp, "POST $uri HTTP/1.1\r\n" );  
  @fwrite( $fp, "Host: $host:$port\r\n" );
  @fwrite( $fp, "Authorization: Basic $login\r\n" );
  @fwrite( $fp, "User-Agent: wordpress-twitterposts\r\n" );
  @fwrite( $fp, "Content-type: application/x-www-form-urlencoded\r\n" );  
  @fwrite( $fp, "Content-length: ".strlen($content)."\r\n" );
  @fwrite( $fp, "Connection: close\r\n" );  
  @fwrite( $fp, "\r\n" );  
  @fwrite( $fp, $content );
  
  // receive
  $response = '';
  while( !@feof($fp) ) {
    $response.= @fread( $fp, 255 );
  }

  // close
  @fclose( $fp );
  
  // explode response
  $response = explode( "\r\n\r\n", trim($response) );
  $content = $response[1];  
  $header = explode( "\r\n", $response[0] );
  $headerarray = array();
  foreach( $header as $headerline ) {
    $seperator = ": ";
    $seperator_pos = strpos( $headerline, $seperator );
    $key = substr( $headerline, 0, $seperator_pos );
    $value = substr( $headerline, $seperator_pos+strlen($seperator) );
    $headerarray[ strtolower(trim($key)) ] = strtolower(trim($value));
  }
  $header = $headerarray;

  // return success
  if( $header['status']=='200 ok' )
    return true;
    
  // set error code
  $error = array();
  preg_match( '/(.*)<error>(.*)<\/error>(.*)/s', $content, $error );
  $r_error_code = $header['status'];
  $r_error_text = $error[2];
    
  // return error
  return false;
  }
}
	//=============================================
    // Displays The Options Panel
    //=============================================
function options_panel() {
		if(isset($_POST['commentwitter-option-submitted']))
			{

				$settings=array();
				$settings['commentwitter_api']=$_POST['commentwitter_api'];
				$settings['commentwitter_cligs_api']=$_POST['commentwitter_cligs_api'];
				$settings['commentwitter_twitter_name']=$_POST['commentwitter_twitter_name'];
				$settings['commentwitter_twitter_pass']=$_POST['commentwitter_twitter_pass'];
				$settings['commentwitter_prefix']=$_POST['commentwitter_prefix'];
				$settings['commentwitter_whats_this']=$_POST['commentwitter_whats_this'];
				
				$setting_str = serialize($settings);
			
				if(get_option('commentwitter_settings'))
					update_option("commentwitter_settings", $setting_str);
				else
					add_option("commentwitter_settings", $setting_str, '', 'yes');
			}//updated

			$settings=unserialize(get_option('commentwitter_settings'));
		
			commentwitter_show_options($settings);
		}

function commentwitter_show_options($settings)
{	
	?>
		
		
		<div class="wrap">
			<h2>CommenTwitter Settings</h2>
           
          <form method="post" action="">
			<table class="form-table">
            <tr valign="top">
				<td colspan="2"><p><strong>Input your Twitter credentials if you wish to automatically tweet new comments on your blog to your Twitter account. You can also choose to ad a small note before your Tweets like &quot;New Comment:&quot;.</strong></p>
				</td>
			</tr>
            <tr valign="top">
				<th scope="row"><?php _e("Twitter Username");?>
				</th>
				<td><input type="text" name="commentwitter_twitter_name" value="<?php echo $settings['commentwitter_twitter_name']; ?>" />
				</td>
			</tr>
            <tr valign="top">
				<th scope="row"><?php _e("Twitter Password");?>
				</th>
				<td><input type="password" name="commentwitter_twitter_pass" value="<?php echo $settings['commentwitter_twitter_pass']; ?>" />
				</td>
			</tr>
            <tr valign="top">
				<th scope="row"><?php _e("Preface Tweet with:");?>
				</th>
				<td><input type="text" name="commentwitter_prefix" value="<?php echo $settings['commentwitter_prefix']; ?>" />
				</td>
			</tr>
            <tr valign="top">
				<td colspan="2"><p><strong>This plugin allows you to track any cli.gs made through Commentwitter.</strong></p>
            <p>To enable this feature:<br />
            1) Go to <a href="http://cli.gs" target="_blank">http://cli.gs</a> and create a new account<br />
            2) Click on "My API Keys" in the navigation menu<br />
            3) Click "Create New API Key"<br />
            4) Copy your API Key into the box below and click "Save Settings"
			</p>
				</td>
			</tr>
			<tr valign="top">
				<th scope="row"><?php _e("Cligs API Key");?>
				</th>
				<td><input type="text" name="commentwitter_cligs_api" value="<?php echo $settings['commentwitter_cligs_api']; ?>" />
				</td>
			</tr>
            <tr valign="top">
				<td colspan="2"><p><strong>If you like this plugin please considor donating a few bucks to support it's development. <a href="https://www.paypal.com/cgi-bin/webscr?cmd=_donations&amp;business=USAWALL82PX3E&amp;lc=US&amp;currency_code=USD&amp;bn=PP%2dDonationsBF%3abtn_donate_SM%2egif%3aNonHosted" target="_blank">>>Donate Here <<</a></strong></p>
				</td>
			</tr>
            <tr valign="top">
				<th scope="row"><?php _e("Show 'What's This?' Button");?>
				</th>
				<td>
                <input type=CHECKBOX NAME="commentwitter_whats_this" 
                <?
				if(get_option('commentwitter_settings')){
					$settings=array();
					$settings=unserialize(get_option('commentwitter_settings'));
				} else {
					$settings=array();
					$settings['commentwitter_whats_this']="on";
				}
				if($settings['commentwitter_whats_this']){
						echo "checked";
				} 
				?>
				 />
				</td>
			</tr>
			<tr valign="top">
			<th colspan='2' scope='row'>
					<input class="sub" type="submit" name="commentwitter-option-submitted" value="<?php _e('Save Settings') ?> &raquo; " />
			</th>
			</tr>
			</table>
			</form>
		</div>
		<?php
	}

	//=============================================
    // admin options panel
    //=============================================
    function add_options_subpanel() {
        if (function_exists('add_options_page')) {
          add_options_page('CommenTwitter', 'CommenTwitter', 10, __FILE__, 'options_panel');
        }
    }

function enqueue_jquery() {
    wp_enqueue_script('jquery');
}

function Commentwitter_approval_check($new_status){
		if ($new_status==1||$new_status=='approve'||$new_status=='approved'){
			Author_twitter_send($comment_id,"approved");
	}
}

function Author_twitter_send($comment_id, $comment_status) {

	//global $user_ID, $userdata, $twitteraccountname;
	if ($comment_status==""){$comment_status=wp_get_comment_status($comment_id);}
	if ($comment_status=="approved"||$comment_status==1||$comment_status=="approve"){
		//First get the post that the comment is a response to
		$comment = get_comment($comment_id);
		$post_id = $comment->comment_post_ID;
		$content = $comment->comment_content ;
		$thispostlink = get_permalink($post_id);
		$post = get_post($post_id);
		$thisposttitle = $post->post_title;
		
		if(get_option('commentwitter_settings')){
			$settings=array();
			$settings=unserialize(get_option('commentwitter_settings'));
		} else {
			$settings=array();
			$settings['commentwitter_twitter_name']="";
			$settings['commentwitter_twitter_pass']="";
			$settings['commentwitter_prefix']="";
		}
		
		if($settings['commentwitter_prefix']!=""){
			$content = $settings['commentwitter_prefix'] . " " . $content;
		}
		
		$tweet  = stripslashes(trim($content));
		$twit = Create_tweet($tweet, $thispostlink, $thisposttitle);
	
		$error_code = null; 
		$error_text = null;
		
		if($settings['commentwitter_twitter_name']!="" && $settings['commentwitter_twitter_pass']!=""){
			$twitname = $settings['commentwitter_twitter_name'];
			$twitpass = $settings['commentwitter_twitter_pass'];
			
			$retval = Commenter_twitter_send( $twit, $twitname, $twitpass, $error_code, $error_text );
			
		} 
	}
}



/*
	adding actions & filter
*/
//Add comment approval form processing
add_action('transition_comment_status','Commentwitter_approval_check');

//
add_action ('wp_print_scripts', 'enqueue_jquery', 1);

//Add admin page
add_action('admin_menu','add_options_subpanel');

//Add Javascript to header
add_action('wp_head', 'Commentwitter_wp_head');

// add comment form processing
add_action('comment_post', 'Commentwitter_form_action', 75); // very low priority so spam measures take place first
?>